#
# spec file for package gegl
#
# Copyright (c) 2018 SUSE LINUX GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#


Name:           gegl
Version:        0.3.34
Release:        3.3.1
Summary:        Generic Graphics Library
License:        GPL-3.0-or-later AND LGPL-3.0-or-later
Group:          Productivity/Graphics/Other
URL:            http://gegl.org/
Source0:        https://download.gimp.org/pub/gegl/0.3/%{name}-%{version}.tar.bz2
# PATCH-FIX-UPSTREAM gegl-CVE-2021-45463.patch CVE-2021-45463 bsc#1194045 qkzhu@suse.com -- use more robust g_spawn_async() instead of system()
Patch0:         gegl-CVE-2021-45463.patch
BuildRequires:  ImageMagick
BuildRequires:  SDL-devel >= 1.2.0
BuildRequires:  enscript
BuildRequires:  gcc-c++
BuildRequires:  gobject-introspection-devel >= 1.32.0
BuildRequires:  graphviz-gd
BuildRequires:  gtk-doc
BuildRequires:  libjpeg-devel
BuildRequires:  libspiro-devel
BuildRequires:  libstdc++-devel
BuildRequires:  libtool
BuildRequires:  pkgconfig
BuildRequires:  suitesparse-devel
BuildRequires:  pkgconfig(OpenEXR) >= 1.6.1
BuildRequires:  pkgconfig(babl) >= 0.1.46
BuildRequires:  pkgconfig(cairo) >= 1.12.2
BuildRequires:  pkgconfig(exiv2) >= 0.25
BuildRequires:  pkgconfig(gdk-pixbuf-2.0) >= 2.32.0
BuildRequires:  pkgconfig(gexiv2)
BuildRequires:  pkgconfig(gio-2.0)
BuildRequires:  pkgconfig(gio-unix-2.0)
BuildRequires:  pkgconfig(glib-2.0) >= 2.44.0
BuildRequires:  pkgconfig(gmodule-2.0)
BuildRequires:  pkgconfig(gobject-2.0)
BuildRequires:  pkgconfig(gthread-2.0)
BuildRequires:  pkgconfig(jasper) >= 1.900.1
BuildRequires:  pkgconfig(json-glib-1.0)
BuildRequires:  pkgconfig(lcms2) >= 2.8
BuildRequires:  pkgconfig(libavcodec) < 58
BuildRequires:  pkgconfig(libavformat) < 58
BuildRequires:  pkgconfig(libpng) >= 1.6.0
BuildRequires:  pkgconfig(libraw) >= 0.15.4
BuildRequires:  pkgconfig(librsvg-2.0) >= 2.40.6
BuildRequires:  pkgconfig(libswscale) < 5
BuildRequires:  pkgconfig(libtiff-4) >= 4.0.0
BuildRequires:  pkgconfig(libv4l2) >= 1.0.1
BuildRequires:  pkgconfig(libwebp) >= 0.5.0
BuildRequires:  pkgconfig(lua) >= 5.1.0
BuildRequires:  pkgconfig(pango) >= 1.38.0
BuildRequires:  pkgconfig(pangocairo) >= 1.38.0
BuildRequires:  pkgconfig(vapigen) >= 0.20.0
# since version 0.3.5, we no longer provide an orig-addon package, as ffmpeg/libav
# exists in Tumbleweed and we use it to build
Provides:       %{name}-0_3-orig-addon = %{version}
Obsoletes:      %{name}-0_3-orig-addon < 0.3.5
# Since 13/02/18 (version 0.3.28) gegl-unstable is obsolete, gegl is now on "0.3" branch.
Provides:       gegl-unstable = %{version}
Obsoletes:      gegl-unstable < %{version}

%description
GEGL provides infrastructure to do demand based cached non destructive
image editing on larger than RAM buffers. Through babl, it provides
support for a wide range of color models and pixel storage formats for
input and output.

%package -n %{name}-0_3
Summary:        Generic Graphics Library
Group:          System/Libraries
Recommends:     %{name}-0_3-lang

%description -n %{name}-0_3
GEGL provides infrastructure to do demand based cached non destructive
image editing on larger than RAM buffers. Through babl, it provides
support for a wide range of color models and pixel storage formats for
input and output.

%package -n libgegl-0_3-0
Summary:        Generic Graphics Library
# The plugins are required for the lib to be usable
Group:          System/Libraries
Requires:       %{name}-0_3 >= %{version}

%description -n libgegl-0_3-0
GEGL provides infrastructure to do demand based cached non destructive
image editing on larger than RAM buffers. Through babl, it provides
support for a wide range of color models and pixel storage formats for
input and output.

%package -n typelib-1_0-Gegl-0_3
Summary:        Introspection bindings for the GEGL "Generic Graphics Library"
Group:          System/Libraries

%description -n typelib-1_0-Gegl-0_3
GEGL provides infrastructure to do demand based cached non destructive
image editing on larger than RAM buffers. Through babl, it provides
support for a wide range of color models and pixel storage formats for
input and output.

This package provides the GObject Introspection bindings for the
libgegl library.

%package devel
Summary:        Development files for the GEGL "Generic Graphics Library"
Group:          Development/Libraries/C and C++
Requires:       libgegl-0_3-0 = %{version}
Requires:       typelib-1_0-Gegl-0_3 = %{version}

%description devel
GEGL provides infratructure to do demand based cached non destructive
image editing on larger than RAM buffers. Through babl, it provides
support for a wide range of color models and pixel storage formats for
input and output.

%package doc
Summary:        Documentation for the GEGL "Generic Graphics Library"
Group:          Documentation/HTML

%description doc
GEGL provides infrastructure to do demand based cached non destructive
image editing on larger than RAM buffers. Through babl, it provides
support for a wide range of color models and pixel storage formats for
input and output.

%lang_package -n %{name}-0_3

%prep
%autosetup -p1

%build
%configure \
	--disable-static \
	%{nil}
make %{?_smp_mflags}

%install
%make_install
find %{buildroot} -type f -name "*.la" -delete -print
%find_lang %{name}-0.3 %{?no_lang_C}

%post -n gegl-0_3 -p /sbin/ldconfig
%postun -n gegl-0_3 -p /sbin/ldconfig

%post -n libgegl-0_3-0 -p /sbin/ldconfig
%postun -n libgegl-0_3-0 -p /sbin/ldconfig

%files
%{_bindir}/gegl
%{_bindir}/gegl-imgcmp
%{_bindir}/gcut

%files -n %{name}-0_3
%dir %{_libdir}/gegl-0.3/
%{_libdir}/gegl-0.3/*.so
# libgegl-sc-0.3.so is a support library for the seamless-clone module
%{_libdir}/libgegl-sc-0.3.so
%{_libdir}/libgegl-npd-0.3.so
%{_libdir}/gegl-0.3/grey2.json

%files -n libgegl-0_3-0
%license COPYING COPYING.LESSER
%{_libdir}/libgegl-0.3.so.*

%files -n typelib-1_0-Gegl-0_3
%{_libdir}/girepository-1.0/Gegl-0.3.typelib

%files devel
%{_includedir}/gegl-0.3/
%{_libdir}/libgegl-0.3.so
%{_libdir}/pkgconfig/gegl-0.3.pc
%{_libdir}/pkgconfig/gegl-sc-0.3.pc
%{_datadir}/gir-1.0/Gegl-0.3.gir
%dir %{_datadir}/vala
%dir %{_datadir}/vala/vapi
%{_datadir}/vala/vapi/gegl-0.3.deps
%{_datadir}/vala/vapi/gegl-0.3.vapi

%files doc
%doc AUTHORS ChangeLog NEWS
%doc %{_datadir}/gtk-doc/html/gegl/

%files -n %{name}-0_3-lang -f %{name}-0.3.lang

%changelog
* Fri Dec 24 2021 qkzhu@suse.com
- Add gegl-CVE-2021-45463.patch:
  + use more robust g_spawn_async() instead of system()
    https://gitlab.gnome.org/GNOME/gegl/-/commit/bfce470
  + pass redirect to /dev/null flags to g_spawn_async
    https://gitlab.gnome.org/GNOME/gegl/-/commit/2172cf7
    (CVE-2021-45463, bsc#1194045).
* Thu Apr 26 2018 fcrozat@suse.com
- Do not buildrequires lensfun-devel, it would be only used when
  building workshop, if Makefile was really compiling relevant
  code.
* Sun Apr 22 2018 bjorn.lie@gmail.com
- Explicitly version pkgconfig(libavcodec), pkgconfig(libavformat)
  and pkgconfig(libswscale) BuildRequires to less than the symbol
  versions provided by ffmpeg4 branch until upstream catches up.
  Currently provided by new ffmpeg3 compatability package.
* Wed Apr 18 2018 bjorn.lie@gmail.com
- Update to version 0.3.34 (CVE-2018-10114):
  + Core: Change GeglParamSpecSeed from int to uint to match the
    value range of GeglRandom's seed.
  + Operations: Limit allocations in ppm-load to 2GB
    (CVE-2018-10114).
- Changes from version 0.3.32:
  + Operations:
  - panorama-projection: added reverse transform, which permits
    using GIMP for retouching zenith, nadir or other arbitrary
    gaze directions in equirectangular, also known as 360x180
    panoramas.
  - Added abyss-policy to base class for scale ops, making it
    possible to achieve hard edges on rescaled buffers.
  + GeglBuffer:
  - Improved performance and correctness, avoid incorrectly
    gamma/ungamma correcting alpha in u8 formats, for a tiny 2-3%%
    performance boost.
  - Keep track of valid/invalid areas on smaller granularity than
    tiles in mipmap.
  - Various micro-optimizations in display paths, with minuscle
    performance impact.
* Sun Apr  1 2018 luc14n0@linuxmail.org
- Add cairo and glib-2.0 BuildRequires to avoid implicit
  dependencies.
* Thu Mar 29 2018 plinnell@opensuse.org
- Update to version 0.3.30:
  + GeglBuffer:
  - gegl_buffer_get now treats the final argument;
  - All scaling is now done on linear data, making future results
    of mipmap computations more valid as well as providing
    correct results for scaled down thumbnails in user
    interfaces;
  - The scaling code paths has also been instrumented and
    optimized for performance;
  - Improvements to logic switching to boxfiltering behavior and
    improve cubic samplers box filtering by using a linear
    sampler and a nearest sampler for the boxfiltering for the
    linear sampler;
  - gegl_buffer_copy gegl_buffer_clear and gegl_buffer_set color
    now only emit a single changed signal on the buffer.
  + Operations:
  - c2g and stress have gained the ability to toggle the
    influence of the shadow neighborhood or not, the new default
    is to not improve shadow detail; yielding a bit more natural
    renditions;
  - color-to-alpha now contains improvements from experiment
    in workshop which is gone;
  - Fixed crashes in median-blur.
  + Transform ops: Only rasterize inside the transformed polygon,
    saving cpu;
  + New ops: Mean-curvature blur.
  + News ops in workshop: color-overlay, enlarge, inpaint, domain-\
    transform, recursive=transform.
- Now minimum build requirement for GIMP 2.10.0
* Tue Mar 13 2018 bjorn.lie@gmail.com
- Update to version 0.3.28:
  + New stable branch, long packaged as gegl-unstable in openSUSE,
    changes far to many to list, please see NEWS packaged in
    docs sub-package.
- Lots of BuildRequires, Requires and sub-package changes.
- Drop upstream fixed patches:
  + gegl-UF_long.patch.
  + gegl-lua52.patch.
  + gegl-0.2.0-CVE-2012-4433.patch.
  + gegl-ruby19.patch.
  + gegl-0.2.0-linker-flags.patch
* Wed Mar  7 2018 jengelh@inai.de
- Fix SRPM group. Update descriptions. Remove idempotent
  %%if..%%endif around %%package.
* Wed Feb 28 2018 dimstar@opensuse.org
- Modernize spec-file by calling spec-cleaner
* Wed Jan 24 2018 pgajdos@suse.com
- require liberation-fonts instead of liberation2-fonts, it is dead
  [bsc#1077375] [rh#856239]
* Fri Jan 12 2018 dimstar@opensuse.org
- Replace liberation-fonts BuildRequires with liberation2-fonts:
  the new set works as well.
* Sun Feb  5 2017 zaitor@opensuse.org
- Fix CVE-2012-4433 (bsc#789835):
  + Add gegl-0.2.0-CVE-2012-4433.patch: Fix buffer overflow in and
    add plausibility checks to ppm-load op.
* Sat Apr 16 2016 olaf@aepfle.de
- Use pkgconfig instead of libffmpeg-devel
* Tue Jan 26 2016 idonmez@suse.com
- Add gegl-0.2.0-linker-flags.patch to add -lm to linker flags.
* Sat Oct 25 2014 i@marguerite.su
- fix build for factory
  * add patch: gegl-UF_long.patch
  * newer suitesparse abandoned UF_long in favor for SuiteSparse_long
- fix build for graphics repo
  * ugly fix, multiple provides of gd by gd and gd-tools from libgd2
* Mon Feb  4 2013 coolo@suse.com
- update license to new format
* Fri May 18 2012 dimstar@opensuse.org
- Add gegl-ruby19.patch: Fix build with ruby 1.9.
- Add liberation-fonts: the documentation references bitstream
  vera sans font, so we need to provide it for the build.
* Tue Apr  3 2012 vuntz@opensuse.org
- Update to version 0.2.0:
  + OpenCL support
  + Build improvements.
  + High level API to apply ops directly to buffers with arguments.
  + Final bits of translation infrastructure.
  + Invalidate regions when disconnecting input pads.
  + Operations:
  - New operation: global-matting
  - Allow transform core to do perspective transforms.
  - Added string based key/value pairs to operations.
  - Added arguments for dealing with scaled down preview
    rendering.
  + Added human interaction ranges and non-linear mapping to
    properties.
  + Buffer:
  - Removed broken lanczos sampler.
  - Add gegl_buffer_set_color and gegl_buffer_set_pattern
  - Added ability to drop cached tiles.
  - Added API for handling abyss policy (not implemented yet)
  - Avoid iterating global tile cache when flushing/destroying
    buffers that have no tiles in the cache.
- Add intltool BuildRequires: new dependency upstream, for
  translations.
- Add lensfun-devel BuildRequires to build with lensfun support.
- Add libexiv2-devel BuildRequires to build with libexiv2 support.
- Add libjasper-devel BuildRequires to build with Jasper support.
- Add libspiro-devel BuildRequires to build with SPIRO support.
- Add suitesparse-devel BuildRequires to build with UMFPACK
  support.
- Uncomment ruby BuildRequires: it was commented out because a file
  was missing in a earlier tarball.
- Rename subpackages from gegl-0_1/libgegl-0_1-0 to
  gegl-0_2/libgegl-0_2-0 following the upstream soname change.
- Create a gegl-0_2-lang subpackage for new translations.
* Wed Jan 11 2012 vuntz@opensuse.org
- Add gegl-lua52.patch: fix build with lua 5.2, while still being
  compatible with lua 5.1.
* Sun Nov 27 2011 dimstar@opensuse.org
- Update to version 0.1.8:
  + New operations: spread, vignette, map-relative,
    noise-reduction, plasma, fractal-trace, exr-save, lens-correct,
    emboss, cubism, ripple, color-to-alpha, color-rotate,
    red-eye-removal, convolution-matrix, deinterlace,
    polar-coordinates, lens-distortion, pixelise.
  + Split GeglView GTK Widget into separate utility library
  + build/test improvements.
  + Buffer:
  - Added lohalo resampler, API and infrastructure for doing non
    affine resamplings.
- Clean spec-file using spec-cleaner.
- Drop docs-build-fix.diff: fixed upstream.
* Mon Jun 20 2011 jw@novell.com
- update to 0.1.6 (see NEWS)
  • New operations: max-rgb, pixelise, motion blur.
  • Fixed a bugs in matting-levin that made GEGL halt due to errors
  detected by babl sanity code, this made 0.1.4 be unusable if you had
  all dependendency when building.
  • build/test improvements.
  • Buffer:
    Added API to use external tile backends, allowing to plug-in alien
    tilebackends, for GIMP/Krita/OSM or similar.
- remove upstreamed patches bgo609706 bgo610680 (thanks, Vincent)
* Thu May  5 2011 dimstar@opensuse.org
- BuildRequire graphviz-gd instead of graphviz: we do require png
  capabilities, which are split out of the main package.
  Theoretically, we should require graphviz-devel, but this package
  also does not drag in -gd.
* Mon Feb 22 2010 vuntz@opensuse.org
- Add gegl-fix-overflow.patch to fix overflow found by gcc 4.5.
* Wed Feb 10 2010 vuntz@opensuse.org
- Update to version 0.1.2:
  + GeglLookup, configurable floating point lookup tables for lazy
    computation.
  + Use GFileIOStream in GeglTileBackendFile.
  + Optimizations: in-place processing for point filters/composers,
    SIMD version of gegl:opacity, avoid making unneccesary
    sub-buffers, removed some  manual instrumentation from critical
    paths, improved speed of samplers.
  + Added xml composition/reference image based regression tests.
  + Added performance tracking framework.
  + Syntactic sugar using varargs for constructing gegl graphs from
    C.
  + Build fixes on cygwin.
  + Gegl# fixes.
  + Initial, but unstable code towards multithreading.
  + Improvements to lua op in workshop.
  + Added new resamplers upsize, upsharp, upsmooth, downsize,
    downsharp and downsmooth.
  + Removed gegl:tonemap and gegl:normal ops.
- Drop gegl-new-babl.patch: fixed upstream.
- Add gegl-fix-build.patch: remove printf that breaks build because
  of missing include.
- Rename package from gegl-0_0 and libgegl-0_0-0 to gegl-0_1 and
  libgegl-0_1-0 following soname bump.
* Thu Jan 28 2010 vuntz@opensuse.org
- Add gegl-new-babl.patch to fix build with babl 0.1.2.
* Mon Jul 20 2009 vuntz@novell.com
- Update to version 0.1.0:
  + Renamed gegl:load-buffer to gegl:buffer-source and
    gegl:save-buffer to gegl:buffer-sink (but the old names still
    work)
  + Represent colors using doubles instead of floats (this change
    is independent from internal processing)
  + Removed the GTK+ UI parts of the gegl binary and turned gegl
    into a pure command line tool (which can still visualize stuff
    with help help the SDL based display operation)
  + Consider {x=G_MININT/2, y=G_MININT/2, width=G_MAXINT,
    height=G_MAXINT} as the only valid region wichin processing
    may occur. Processing outside of this region is undefined
    behaviour.
  + Added support for storing allocation stack traces for
    GeglBuffers so that debuging buffer leaks becomes much easier
  + Made small changes and cleanups of the public API, e.g.
  - Removed gegl_node_adapt_child()
  - Made GeglConfig an explicit object
  - Removed most of the ifdeffed stuff to mask away internal
    structures
  - Added gegl_rectangle_infinite_plane() and
    gegl_rectangle_is_infinite_plane()
  + Added new sampler GeglSamplerSharp
  + Added format property go gegl:buffer-sink
  + Cleaned up and made gegl:introspect work again
  + Add a bunch of test cases using the automake test sytem (make
    check) and also port buffer tests to automake
  + General cleanups, bug fixes, increased robustness and improved
    documentation
- Drop gegl-babl_api_change.patch: fixed upstream.
- Temporarly remove ruby BuildRequires as the build is broken when
  it's there right now.
* Thu Jun 11 2009 vuntz@novell.com
- Add gegl-babl_api_change.patch to make gegl build with babl
  0.1.0. Patch taken from Fedora.
- Remove autoreconf call.
- Do not make gegl0_0 explicitly Requires libbabl-0_0-0.
* Wed Dec 31 2008 hfiguiere@suse.de
- Update to 0.0.22
  * GeglOperation
  - operation names are now prefixed, the ops in GEGL use 'gegl:' as prefix.
  - gegl:opacity - combine value and aux mask input when both are available.
  - gegl:src-in - deal correctly with extens.
  - gegl:path - new op covering the stroke/fill needs of SVG.
  - deprecated gegl:shift, the affine familiy of operations now
    uses the same fast code paths for integer translations.
  * GeglBuffer
  - Profiling motivated speed ups in data reading/writing.
  - Remove left-over swapfiles from dead processes at startup.
  * GeglNode
  - made gegl_node_add_child and gegl_node_remove_child public API. (bgo#507298)
  * GeglPath: Vector path representation infrastructure,
- Remove gegl-64bit-warning.diff
* Mon Oct  6 2008 hfiguiere@suse.de
- Update to 0.0.20
  * libopenraw support
  * Linear buffer support, amongst other things enabling GeglBuffer API access
    to external linear buffers in memory.
  * Reworked samplers using a shared caching neighbourhood infrastructure.
  * YAFR - a new resampler contributed by Nicolas Robidoux.
  * Marked user visible strings for translation.
  * Added a fill operation (might be a bit fragile) that allows rendering
    SVG like paths backed by a GeglVector.
- Remove gegl-strict-compile-fix.diff
- Added gegl-64bit-warning.diff
  * Address a fatal warning on 64bits
* Wed Oct  1 2008 hfiguiere@suse.de
- Add patch gegl-strict-compile-fix.diff:
  * Fix header for stricter compilation
- enable workshop at compile time
* Mon Sep 29 2008 sbrabec@suse.cz
- Fixed dependencies.
- Fixed permissions of documentation.
* Mon Jul 21 2008 sbrabec@suse.cz
- New SuSE package.
